
// global request and XML document objects
var req = null;
var ticker = null;
var active = 1;
var lastUpd = 0;
var isLoading;
var lastUpdDt = new Date();
var secsBetweenUpdates = 30*60; // http://slashdot.org/faq/accounts.shtml#ac1050
        
// start timers
// ticker = setTimeout("UpdateTicker()", 500); 
var sDt = new Date();
debugOut("START:" + sDt.getTime());
ticker = setInterval("UpdateTicker()", 1000);

// set up handlers
if (window.widget) 
{
    widget.onshow = onshow;
    widget.onhide = onhide;
}

function debugOut(txt)
{
	return;
	
    if (window.widget) debug(txt);
};


function onshow() 
{
    debugOut("SHOW");
    active = 1;
    //loadRSS();
}

function onhide() 
{
    debugOut("HIDE");
    active = 0;
}

function getEl(elID)
{
    var el = document.getElementById(elID);
    return el;
};


function startFlasher()
{
    var el = getEl("loading");
    el.style.display="block";
};

function stopFlasher()
{
    var el = getEl("loading");
    el.style.display="none";
};

function UpdateTicker(tag) 
{
	// ignore if we're supposed to be hidden
	if (active == 0)
	{
		return;
	};

    var d = getEl("lastup");
    var isNeg = 0;
    
    var dt = new Date();
    
    var z = parseInt( (dt.getTime()) / 1000) - lastUpd; 

    var secsLeft = secsBetweenUpdates - z;

    if (secsLeft < 0)
    {
        secsLeft = -secsLeft;
        isNeg = 1;
    };

    debugOut("UpdateTicker: " + secsLeft + ", " + dt.getTime());

    var mins  = parseInt(secsLeft / 60);
    var hours = parseInt(mins / 60);
    var secs = secsLeft - mins * 60 - hours * 3600;
    
    if (mins < 10) mins = "0" + mins;
    if (hours < 10) hours = "0" + hours;
    if (secs < 10) secs = "0" + secs;

    var last = lastUpdDt.toLocaleString();

    var n = "";
    if (isNeg != 1) d.innerHTML="Last update: " + last + ". Next update in " + n + hours + ":" + mins + ":" + secs + ".  ";

    if (secsLeft<=0 || isNeg==1 )
    {
        loadRSS();
    };
    
    //if (isLoading) startFlasher();
    //else stopFlasher();
}

// handle onreadystatechange event of req object
function processReqChange() 
{
    //var el = getEl("content");
        
    debugOut("processReqChange:" + req.readyState + ", " + req.status);

    // only if req shows "loaded"
    if (req.readyState == 4) 
    {
		// ugliness
		var x = "";
		var y = 1;
		try
		{
			x = req.responseText;
			if (x.length > 0)
				debug ( "responseText: " + x.length + " bytes." );
			
			x = req.responseXML;
			if (x)
			{
				debug ( "responseXML exists" );
			};
		}
		catch ( e ) 
		{
			debug ( " no responseXML " );
			x = "";
			y = 0;
		} 	

        // only if "OK"
        if (req.status == 200 || y == 1) 
        {
            //el.style.backgroundColor="green";
			debug ( "calling displayRSS()" );
            displayRSS(req);
        } 
        else
        {
            //el.style.backgroundColor="red";
        }
        isLoading = 0;
        // req = null;
        debugOut("processReqChange: finished");
        stopFlasher();
    }
    else
    {
        //el.style.backgroundColor="yellow";
    }
}

function loadRSS()
{
    //var url = "http://kronk.local.rothwell.us/slashdot.php?";
    //var url = "http://kronk.local.rothwell.us/slashdot.rss";
    //var url = "http://www.softcentral.com/slashdash/slashdot.xml";
    var url = "http://www.slashdot.org/slashdot.rss";

    debugOut("loadRSS: starting");

    // don't overlap
    if (isLoading == 1)
    {
        debugOut("loadRSS: aborting");
        return;
    };

	// crank up progress indicator
	startFlasher();

    // we're loading
    isLoading = 1;

	if (null == req)
    {
        debugOut("creating new XMLHttpRequest");
        req = new XMLHttpRequest();
        req.onreadystatechange = processReqChange;
    }
    else
    {
	    req.abort();
    };
    
	var dt = new Date();
	url = url + "?" + dt.getTime();

    debugOut("requesting: " + url);
	
    req.open("GET", url, true);
    req.send(null);
    
    debugOut("request sent");
};

function lengthLimit(str,len)
{
    if (str.length < len) return str;
    var txt = str.substring(0,len);
    var i = txt.lastIndexOf(" ");
    txt = txt.substring(0,i) + " ...";
    return txt;
};

function displayRSS(reqst)
{
    debugOut("displayRSS: start");

    var el = null;

    try
    {
    	el = getEl("content");
	    el.innerHTML = "Updating!";
	}
	catch ( e )
	{
	    debugOut("el 'content' not found");
		return;
	};

    // clear "last updated" status
    var d = getEl("lastup");
    //d.innerHTML="";
    
    // set new "date last updated"
    lastUpdDt = new Date();
    lastUpd = parseInt(lastUpdDt.getTime()/1000);

    // get XML
    var rss = null;
    try
    {
	   rss = reqst.responseXML.documentElement;
	   debugOut("displayRSS: read reqst.responseXML.documentElement! Yay!");
	} catch ( e )
	{
	    debugOut("displayRSS: failed to read reqst.responseXML.documentElement");
	    d.innerHTML="Request failed";
	    return;
	};

    var itemNodes = rss.getElementsByTagName("item");
    var c=itemNodes.length;
    debugOut("displayRSS: " + c + " items");

	if (c<=0)
	{
	    debugOut("displayRSS: aborting");
		return;
	};

    if (c>4) c=4; // limit to four stories

    //el.innerHTML="Displaying " + c + " items...";
    
    var html = "";

    for (var i = 0; i < c; i++) 
    {
        var itemLink, itemTitle, itemDesc;

        itemTitle = itemNodes[i].getElementsByTagNameNS("http://purl.org/rss/1.0/",'title').item(0).firstChild.nodeValue;
        itemLink = itemNodes[i].getElementsByTagNameNS("http://purl.org/rss/1.0/",'link').item(0).firstChild.nodeValue;
        itemDesc = itemNodes[i].getElementsByTagNameNS("http://purl.org/rss/1.0/",'description').item(0).firstChild.nodeValue;
        
        itemDesc = lengthLimit(itemDesc, 125);
        itemTitle = lengthLimit(itemTitle, 42);
        
        html = html + "<div class='item'><div class='linky' onClick='widget.openURL(\"" + itemLink + "\");'>"+itemTitle+"</div><br/><div class='desc'>"+itemDesc+"</div></div>";

	    debugOut("displayRSS: " + i + ": " + itemTitle);

    };

    // display new content
    el.innerHTML=html;
    html = null;
    el = null;
    req = null;
};



function getElementTextNS(prefix, local, parentElem, index) {
    var result = "";
        // the namespace versions of this method 
        // (getElementsByTagNameNS()) operate
        // differently in Safari and Mozilla, but both
        // return value with just local name, provided 
        // there aren't conflicts with non-namespace element
        // names
	//alert(parentElem.getElementsByTagName("description").length);
        result = parentElem.getElementsByTagName(local)[index];
    if (result) {
        // get text, accounting for possible
        // whitespace (carriage return) text nodes 
        if (result.childNodes.length > 1) {
            return result.childNodes[1].nodeValue;
        } else {
            return result.firstChild.nodeValue;    		
        }
    } else {
        return "n/a";
    }
};


function showBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToBack");
		
    front.style.display="none";
    back.style.display="block";

    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
};

function hideBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToFront");

    back.style.display="none";
    front.style.display="block";

    if (window.widget)
        setTimeout ('widget.performTransition();', 0);

};


var flipShown = false;
	
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
	
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
		
        var starttime = (new Date).getTime() - 13;
		
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}
	

function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
		
        var starttime = (new Date).getTime() - 13;
		
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
    document.getElementById('fliprollie').style.display = 'none';
}
	

function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
		
	
    T = limit_3(time-animation.starttime, 0, animation.duration);
	
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
	
    animation.firstElement.style.opacity = animation.now;
}
	

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
	

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function enterflip(event)
{
    document.getElementById('fliprollie').style.display = 'block';
}


function exitflip(event)
{
    document.getElementById('fliprollie').style.display = 'none';
}



